--- u-boot-2011.06_original/common/cmd_burnotp.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_burnotp.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,236 @@
+#include "cnc_util.h"
+
+#define DEBUG_BURNOTP 0
+//#define debug printf
+#define AUTO_LOCK_OTP 1
+
+#pragma pack(1)
+typedef struct Otp_t
+{
+	UInt32 mOtpBankNo;
+	UInt32 mOtpIndex;
+	UInt32 mOtpData;
+}Otp_t;
+
+#pragma pack(1)
+typedef struct OtpInfo_t
+{
+	UInt32 mNoOfOtpObjectInList;
+	Otp_t mOtpList[1];
+}OtpInfo_t;
+
+static int SkipLockOtpConfirmation;
+
+extern int do_lockotp(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
+extern int do_load_serial_bin(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
+extern int do_otp(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
+
+Int32 Do_Dvu(UInt32 aOtpBufferInputAddress, UInt32 aInputBufferLength, UInt32 aOtpBufferOutputAddress)
+{
+	int Status = Cnc_InPlaceDecryptOnlyImage(aOtpBufferInputAddress,aInputBufferLength);
+	return Status;
+}
+
+int DecryptAndVerifyOtpData(UInt32 aInputAddress, UInt32 aOutputAddress , int aLength)
+{
+	int Status=0;
+	UInt8 SourceHash[32 +256];	
+	UInt8 ComputedHashBuffer[32 + 256];
+	//UInt8 TempBuf[512]; //Backup buffer
+	Status=Status;
+	debug("---------------\n");		
+	memcpy(SourceHash, (void*) (aInputAddress + aLength - 32), 16 );			
+	debug("-----  SourceHash ----------\n");
+	//Cnc_DumpMemory(SourceHash, 8);
+	debug("---------------\n");
+	Status = Cnc_DecryptImageGetHash(aInputAddress, aOutputAddress, aLength-32, ComputedHashBuffer, 16 );
+
+	debug("-----  SourceHash ----------\n");
+	//Cnc_DumpMemory(SourceHash, 8);
+	debug("------  ComputedHashBuffer --------\n");
+	//Cnc_DumpMemory(ComputedHashBuffer, 8);			
+	debug("---------------\n");
+	//Check hash signature 
+	if ( 0 == memcmp( SourceHash, ComputedHashBuffer, 16 ) )
+	{
+		return 0;				
+	}
+	return -1;		
+}
+
+int do_burnotp(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	UInt32 i=0;
+	OtpInfo_t *p;
+	int status = 0;
+	char TempBuf0[16]={0};
+	char TempBuf1[16]={0};
+	char TempBuf2[16]={0};
+	char TempBuf3[16]={0};
+	UInt32 OtpBufferInputAddress =0x02000000;
+	UInt32 OtpBufferOutputAddress=0x02000000;
+	UInt32 cnt;
+
+	const char* pStep2[]     = { "otp"   , "write" , TempBuf1, TempBuf2 , TempBuf3 };
+	const char* kermit_cmd[] = { "loadb" , TempBuf0 };
+	const char* pLockOtp[]     = { "lockotp" };
+	UInt32 FileSize;
+
+	//burnotp kermit
+	//burnotp mem  <memoryaddress>
+	//burnotp usb <file_name>
+
+	memset( (void*)OtpBufferInputAddress , 0xFF, 64*1024);
+	memset( (void*)OtpBufferOutputAddress, 0xFF, 64*1024);
+
+
+	if ( (0 ==  strcmp( argv[1],"kermit" ) ) && (argc == 4) )
+	{
+		sprintf(TempBuf0, "%x", OtpBufferInputAddress);
+		status = do_load_serial_bin(NULL,0, 2 ,(char** const ) kermit_cmd);
+		if ( 0 != status )
+		{
+			printf("%sERROR: kermit failed, try again\n%s", ColorRed, ColorNormal);
+			goto error_exit;
+		}
+	}
+	else if ( ( 0 == strcmp ( argv[1], "mem" ) ) && (argc == 4) )
+	{
+		OtpBufferInputAddress = simple_strtol(argv[2],NULL,16);
+		OtpBufferOutputAddress=OtpBufferInputAddress;
+		FileSize = simple_strtol(argv[3],NULL,16);
+		if (FileSize<1)
+		{
+			printf("%sERROR: filesize too small\n%s", ColorRed, ColorNormal);
+			return -1;
+		}
+
+	}
+	else if ( ( 0 == strcmp( argv[1], "usb" ) ) && (argc == 3 ) )
+	{
+		status = cnc_LoadFileFromUsb(argv[2],  OtpBufferInputAddress , & FileSize);
+		if (status != 0 )
+		{
+			printf("%sERROR: unable to load file from usb\n%s" , ColorRed, ColorNormal );
+			return -1;
+		}
+	}
+	else
+	{
+		cmd_usage(cmdtp);
+		goto error_exit;
+	}
+
+	status = DecryptAndVerifyOtpData(OtpBufferInputAddress, OtpBufferOutputAddress, FileSize);
+	
+	if ( 0 != status )
+	{
+		printf("%sERROR: Fail to verify OTP data, please try again\n%s", ColorRed, ColorNormal );
+		return -1;
+	}	
+	else
+	{
+		printf("%sOTP data verified successfully\n%s", ColorGreen, ColorNormal );
+	}
+
+#if (DEBUG_BURNOTP)
+	Cnc_DumpMemory ( OtpBufferOutputAddress, FileSize/sizeof(UInt32) );
+#endif
+	p = (OtpInfo_t*) OtpBufferOutputAddress;
+	cnt = min( p->mNoOfOtpObjectInList,128);
+	for(i=0 ; i < cnt ; i++)
+	{
+		sprintf(TempBuf1, "0x%X" , p->mOtpList[i].mOtpBankNo);
+		sprintf(TempBuf2, "0x%X" , p->mOtpList[i].mOtpIndex);
+		sprintf(TempBuf3, "0x%08X" , p->mOtpList[i].mOtpData);
+#if (DEBUG_BURNOTP)
+		printf("%s %s %s %s %s\n", pStep2[0], pStep2[1], pStep2[2], pStep2[3], pStep2[4] );
+		status =0;
+#else
+		status = do_otp(NULL, 0, 5, (char** const )pStep2);
+#endif
+
+		if ( status != 0 )
+		{
+#if (DEBUG_BURNOTP)
+			Cnc_DumpMemory ( OtpBufferOutputAddress, FileSize/sizeof(UInt32) );
+#else
+			//wipe out memory before exit
+			memset( (void*) OtpBufferOutputAddress, 0, FileSize);
+#endif
+			printf("%sERROR: OTP programming failed, please contact vendor\n%s" , ColorRed, ColorNormal);
+			return -1;
+		}
+	}
+	//wipe out memory
+	memset( (void*) OtpBufferOutputAddress, 0, FileSize);
+	printf("%sOTP programmed successfully\n%s", ColorGreen, ColorNormal);
+
+#if (AUTO_LOCK_OTP)	
+	SkipLockOtpConfirmation=1;
+	status = do_lockotp(NULL, 0, 1, (char** const )pLockOtp);
+	SkipLockOtpConfirmation=0;
+#endif	
+	
+	return status;
+
+error_exit:
+	return -1;
+}
+
+U_BOOT_CMD(
+		burnotp, 4, 0 , do_burnotp,
+		"burn otp - from file (file can be downloaded via kermit or preloaded from meory or usb",
+		"burnotp kermit\n"
+		"burnotp mem  <memoryaddress> <length>\n"
+		"burnotp usb <file_name>\n"
+	  );
+	  
+	  
+int do_lockotp(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	int status = 0;
+	char temp='N';
+	const char* pStep2[]     = { "otp"   , "write" , "0" , "0x0", "0x00208108"  };
+
+	if ( 0  == SkipLockOtpConfirmation )
+	{
+		printf("%sWARNING:lockotp operation irreversible, Are you sure?, Do you want to continue? (N/Y)\n%s", ColorYellow, ColorNormal);
+		temp = getc();
+	}
+	else
+	{
+		temp = 'Y';
+	}
+	
+	if ((temp == 'Y' ) || (temp == 'y') )
+	{
+		#if (DEBUG_BURNOTP)
+			printf("%s %s %s %s %s\n", pStep2[0], pStep2[1], pStep2[2], pStep2[3], pStep2[4] );
+			status =0;
+		#else
+			status = do_otp(NULL, 0, 5, (char** const) pStep2);
+		#endif
+
+		if ( status != 0 )
+		{
+			printf("%sERROR: Fail to lock OTP. Please contact vedor\n%s", ColorRed, ColorNormal);
+			return -1;
+		}
+		
+		printf("%sOTP is locked successfully\n%s", ColorGreen, ColorNormal);
+	}
+	else
+	{
+		printf("%slockotp operation aborted\n%s", ColorMagenta, ColorNormal);
+	}
+
+	return status;
+}
+	  
+	  
+U_BOOT_CMD(
+		lockotp, 1, 0 , do_lockotp,
+		"lockotp",
+		"lockotp"
+	  );
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_cache.c u-boot-2011.06/common/cmd_cache.c
--- u-boot-2011.06_original/common/cmd_cache.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/common/cmd_cache.c	2014-07-29 17:28:38.819972000 +0800
@@ -2,23 +2,7 @@
  * (C) Copyright 2000
  * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
  *
- * See file CREDITS for list of people who contributed to this
- * project.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation; either version 2 of
- * the License, or (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
- * MA 02111-1307 USA
+ * SPDX-License-Identifier:	GPL-2.0+
  */
 
 /*
@@ -26,73 +10,97 @@
  */
 #include <common.h>
 #include <command.h>
+#include <linux/compiler.h>
+
+static int parse_argv(const char *);
 
-static int on_off (const char *);
+void __weak invalidate_icache_all(void)
+{
+	/* please define arch specific invalidate_icache_all */
+	puts("No arch specific invalidate_icache_all available!\n");
+}
 
-int do_icache ( cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+int do_icache(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
 {
 	switch (argc) {
 	case 2:			/* on / off	*/
-		switch (on_off(argv[1])) {
-		case 0:	icache_disable();
+		switch (parse_argv(argv[1])) {
+		case 0:
+			icache_disable();
 			break;
-		case 1:	icache_enable ();
+		case 1:
+			icache_enable();
+			break;
+		case 2:
+			invalidate_icache_all();
 			break;
 		}
-		/* FALL TROUGH */
+		break;
 	case 1:			/* get status */
-		printf ("Instruction Cache is %s\n",
+		printf("Instruction Cache is %s\n",
 			icache_status() ? "ON" : "OFF");
 		return 0;
 	default:
-		return cmd_usage(cmdtp);
+		return CMD_RET_USAGE;
 	}
 	return 0;
 }
 
-int do_dcache ( cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+void __weak flush_dcache_all(void)
+{
+	puts("No arch specific flush_dcache_all available!\n");
+	/* please define arch specific flush_dcache_all */
+}
+
+int do_dcache(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
 {
 	switch (argc) {
-	case 2:			/* on / off	*/
-		switch (on_off(argv[1])) {
-		case 0:	dcache_disable();
+	case 2:			/* on / off */
+		switch (parse_argv(argv[1])) {
+		case 0:
+			dcache_disable();
+			break;
+		case 1:
+			dcache_enable();
 			break;
-		case 1:	dcache_enable ();
+		case 2:
+			flush_dcache_all();
 			break;
 		}
-		/* FALL TROUGH */
+		break;
 	case 1:			/* get status */
-		printf ("Data (writethrough) Cache is %s\n",
+		printf("Data (writethrough) Cache is %s\n",
 			dcache_status() ? "ON" : "OFF");
 		return 0;
 	default:
-		return cmd_usage(cmdtp);
+		return CMD_RET_USAGE;
 	}
 	return 0;
-
 }
 
-static int on_off (const char *s)
+static int parse_argv(const char *s)
 {
-	if (strcmp(s, "on") == 0) {
-		return (1);
-	} else if (strcmp(s, "off") == 0) {
-		return (0);
-	}
-	return (-1);
+	if (strcmp(s, "flush") == 0)
+		return 2;
+	else if (strcmp(s, "on") == 0)
+		return 1;
+	else if (strcmp(s, "off") == 0)
+		return 0;
+
+	return -1;
 }
 
 
 U_BOOT_CMD(
 	icache,   2,   1,     do_icache,
 	"enable or disable instruction cache",
-	"[on, off]\n"
-	"    - enable or disable instruction cache"
+	"[on, off, flush]\n"
+	"    - enable, disable, or flush instruction cache"
 );
 
 U_BOOT_CMD(
 	dcache,   2,   1,     do_dcache,
 	"enable or disable data cache",
-	"[on, off]\n"
-	"    - enable or disable data (writethrough) cache"
+	"[on, off, flush]\n"
+	"    - enable, disable, or flush data (writethrough) cache"
 );
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_call_external_proc.c u-boot-2011.06/common/cmd_call_external_proc.c
--- u-boot-2011.06_original/common/cmd_call_external_proc.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_call_external_proc.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,199 @@
+#include <common.h>
+#include <command.h>
+
+#define EXTERNAL_PIC_PROCESSES_GET_KEY_WORD_CMD 'K'
+#define EXTERNAL_PIC_PROCESSES_GET_FILE_SIZE_CMD 'F'
+#define EXTERNAL_PIC_PROCESSES_GET_CONTEXT_SIZE_CMD 'C'
+
+#define EXTERNAL_PROCS_MAX_ARGC 9
+DECLARE_GLOBAL_DATA_PTR;
+
+struct external_code_attr{
+	unsigned int key_word;
+	unsigned char *addr;
+	unsigned int file_size;
+	unsigned int file_crc;
+	unsigned int context_size;  
+};
+
+int do_call_external_proc (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+#define PIC_PROC_HAS_SEPERATE_SPACE
+	extern unsigned long do_go_exec (unsigned long (*entry)(int, char * const []), int argc, char * const argv[]);
+	static unsigned int magic[] = {0xe1a00000, 0xe1a00000};
+	unsigned int *app;
+	int ret=0;
+	struct external_code_attr this_code_attr[16]={{0}};
+	int i;
+	int found=0;
+	char *p=NULL;
+	unsigned int file_crc;
+	unsigned char *app_aligned_buf=(unsigned char*)CONFIG_ALIGNED_PIC_PROC_MEM_BASE;
+	unsigned int *q;
+
+	if(argc > EXTERNAL_PROCS_MAX_ARGC)
+	{
+		printf("The count of arguments should be less than %d.\n",EXTERNAL_PROCS_MAX_ARGC);
+		return -1;
+	}
+
+	if(1 == argc)
+	{
+		printf("%s",cmdtp->help);
+		return -1;
+	}
+
+	app = (unsigned int *)(gd->relocaddr+(unsigned long)_bss_end_ofs);
+
+	for(i=0;i<sizeof(this_code_attr)/sizeof(struct external_code_attr);i++)
+	{
+		char *argument[1];
+		char argv_0[2]={0};
+		argument[0]=argv_0;
+
+		memcpy(app_aligned_buf,app,0x300);
+		q=(unsigned int *)app_aligned_buf;	
+
+		if(q[0] == magic[0] && q[1] == magic[1]) 
+		{	  
+			argv_0[0]=EXTERNAL_PIC_PROCESSES_GET_KEY_WORD_CMD;
+			ret = do_go_exec((void*)app_aligned_buf, 1, argument);
+			if(ret>0)
+			{
+				this_code_attr[i].key_word=ret;
+			}
+			argv_0[0]=EXTERNAL_PIC_PROCESSES_GET_FILE_SIZE_CMD;
+			ret = do_go_exec((void*)app_aligned_buf, 1, argument);
+			if(ret>0)
+			{
+				this_code_attr[i].file_size=ret;
+			}
+			argv_0[0]=EXTERNAL_PIC_PROCESSES_GET_CONTEXT_SIZE_CMD;
+			ret = do_go_exec((void*)app_aligned_buf, 1, argument);
+			if(ret>0)
+			{
+				this_code_attr[i].context_size=ret;
+			}
+			this_code_attr[i].addr=(unsigned char *)app;
+			file_crc=crc32 (0, (uchar *)this_code_attr[i].addr, this_code_attr[i].file_size);
+			this_code_attr[i].file_crc=file_crc;
+			app=(unsigned int *)((unsigned int)app+this_code_attr[i].file_size); //try to get the next PIC processes.
+		}
+		else
+		{
+			break;
+		}
+	}
+
+	if(q[0] == magic[0] && q[1] == magic[1])
+	{
+		printf("Too many PIC processes! We only contains %d proecesses.\n",sizeof(this_code_attr)/sizeof(struct external_code_attr));
+	}
+
+	//skip the "call_external_proc" command.
+	argc-=1;
+	argv++;  
+
+	if(0==strcmp(argv[0],"list"))
+	{
+		for(i=0;i<sizeof(this_code_attr)/sizeof(struct external_code_attr);i++)
+		{
+			if(0!=this_code_attr[i].key_word)
+			{
+				p=(char *)(&this_code_attr[i].key_word);
+				printf("%d:key_word=[%c%c%c%c],addr=[0x%X],file_crc=[0x%X],file_size=[0x%X],context_size=[0x%X].\n",
+						i,p[3],p[2],p[1],p[0],(unsigned int)this_code_attr[i].addr,this_code_attr[i].file_crc,this_code_attr[i].file_size,this_code_attr[i].context_size);
+			}
+			else
+			{
+				break;
+			}
+		}
+	}
+	else
+	{
+		int key_num=(argv[0][0]<<24|argv[0][1]<<16|argv[0][2]<<8|argv[0][3]);
+		int icache_flag=0;
+
+		for(i=0;i<sizeof(this_code_attr)/sizeof(struct external_code_attr);i++)
+		{
+			if(key_num == this_code_attr[i].key_word)
+			{
+#ifndef PIC_PROC_HAS_SEPERATE_SPACE	  	
+				unsigned char *app_ori_buf=NULL;
+#endif		
+				found=1;
+
+				if(CONFIG_UBOOT_EXTERNAL_PROC_LEN<this_code_attr[i].context_size)
+				{
+					printf("ERROR:The context exceed CONFIG_UBOOT_EXTERNAL_PROC_LEN bytes, it's too big to execute in PIC proc buffer.\n");
+					break;
+				}
+
+#ifndef PIC_PROC_HAS_SEPERATE_SPACE        
+				app_ori_buf=(unsigned char *)malloc(((this_code_attr[i].context_size+(sizeof(unsigned int)-1)))&(~(sizeof(unsigned int)-1)));
+				if(NULL==app_ori_buf)
+				{
+					printf("%s:malloc failed,size is 0x%X bytes.\n",__FUNCTION__,this_code_attr[i].context_size);
+					break;    
+				}
+				app_aligned_buf=(unsigned char *)(((int)(app_ori_buf+(sizeof(unsigned int)-1)))&(~(sizeof(unsigned int)-1)));
+#else        
+				app_aligned_buf=(unsigned char*)CONFIG_ALIGNED_PIC_PROC_MEM_BASE;
+#endif
+				memcpy(app_aligned_buf,this_code_attr[i].addr,this_code_attr[i].file_size);
+				//disable icache
+				if(0!=icache_status())
+				{
+					icache_flag=1;
+					icache_disable();
+				}
+				if(0!=dcache_status())
+				{
+					//flush dcache.
+					dcache_disable();
+					dcache_enable();
+				}
+				ret = do_go_exec((void*)app_aligned_buf, argc, argv);
+				//enable icache if needed.
+				if(1==icache_flag)
+				{
+					icache_enable();
+				}
+
+#ifndef PIC_PROC_HAS_SEPERATE_SPACE        
+				if(NULL != app_ori_buf)
+				{
+					free(app_ori_buf);
+					app_ori_buf=NULL;
+				}        
+#endif    
+				break;
+			}	  
+		}  
+
+		if(0 == found)
+		{
+			printf("Can not find any PIC processes whose key word is [%s].\n",argv[0]);
+		}
+	}
+
+#ifndef PIC_PROC_HAS_SEPERATE_SPACE
+	if(NULL != ori_buf)
+	{
+		free(ori_buf);
+		ori_buf=NULL;
+	}
+#endif
+
+	return 0;
+
+}
+
+U_BOOT_CMD(
+		call_external_proc, EXTERNAL_PROCS_MAX_ARGC, 0, do_call_external_proc,
+		"call external PIC process.\n",
+		"list - list attribute of all the PIC processes\n"
+		"call_external_proc key_word [args..] - call the process whose key word is \"key_word\".\n"		
+	  );
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_cnc1900_audio.c u-boot-2011.06/common/cmd_cnc1900_audio.c
--- u-boot-2011.06_original/common/cmd_cnc1900_audio.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_cnc1900_audio.c	2015-08-20 19:25:54.678159000 +0800
@@ -0,0 +1,356 @@
+/*
+ * (C) Copyright 2000
+ * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#include <common.h>
+#include <command.h>
+
+#include <cnc1900_clock_reg.h>
+#include <cnc1900_audio_reg.h>
+
+#define power_clk_write(a,v) *((volatile unsigned int *)(a)) = v
+#define power_clk_read(a)    (*((volatile unsigned int *)(a)))
+
+#define write_ahb32(a,v) *((volatile unsigned int *)(a)) = v
+#define read_ahb32(a)    (*((volatile unsigned int *)(a)))
+
+//Audio
+typedef enum _AUDIO_CLOCK_MODE_e_
+{
+	_AUDIO_192KHz       ,
+	_AUDIO_176KHZ		,
+	_AUDIO_128KHZ		,
+	_AUDIO_96KHz 		,
+	_AUDIO_88_2KHz		,
+	_AUDIO_64KHz		,
+	_AUDIO_48KHz		,
+	_AUDIO_44_1KHz		,
+	_AUDIO_32KHz		,
+	_AUDIO_24KHz		,
+	_AUDIO_22_05KHz		,
+	_AUDIO_16KHz		,
+	_AUDIO_12KHz		,
+	_AUDIO_11_025KHz	,
+	_AUDIO_8KHz	        ,
+}AUDIO_CLOCK_MODE;
+
+enum aud_pll_postdiv {
+    aud_target_freq      ,
+	audpll_div_F         ,
+	audpll_div_Q         ,
+	audclk_postdiv
+};
+
+
+static const unsigned int aud_pll_cfg[16][4] =
+{   //target_freq  audpll_div_F  audpll_div_Q  audclk_postdiv 
+	{  192000,      32768000,      8,                  2     },   
+	{  176400,      35665850,      8,                  2     }, 
+	{  128000,      32768000,      8,                  3     }, 
+	{   96000,      32768000,     17,                  2     },   
+	{   88200,      64198531,     19,                  2     },            
+	{   64000,      32768000,     26,                  2     },       
+	{   48000,      32768000,     23,                  3     },       
+	{   44100,      33349886,     10,                  7     },       
+	{   32000,      32768000,     26,                  4     }, 
+	{   24000,      62086737,     18,                  8     },       
+	{   22050,      64198531,     19,                  8     },       
+	{   16000,      32768000,     26,                  8     }, 
+	{   12000,      62086737,     18,                 16     },       
+	{   11025,      64198531,     19,                 16     },       
+	{    8000,      63195429,     27,                 16     }      
+};
+
+typedef unsigned int U32;
+typedef unsigned short U16;
+typedef unsigned char U8;
+
+typedef enum
+{
+    I2S_SUCCESS = 0,
+    I2S_FAILED,
+}I2S_RETURN_VALUE;
+
+
+typedef enum
+{
+    I2S_0 = 0,
+    I2S_1,        
+    I2S_2,        
+    I2S_3,        
+}I2S_ID;
+
+typedef struct i2s_element_s
+{
+    I2S_ID i2s_id;
+    U32 UP0;
+    U32 LOW0;
+    U32 SCAL0; // Q24
+    U32 UP1;
+    U32 LOW1;
+    U32 SCAL1; // Q24
+    U8 mixing;
+    U8 todac;
+    U8 tohdmi;    
+    U8 unify;
+    U8 mix_sync;
+    
+}I2S_ELEMENT_t;
+
+typedef union _I2S_CONTROL
+{
+	U32 audio_i2s_control;
+	struct _bits_t
+	{
+		U32 invert_WS					:1	;
+		U32 lsb_first   				:1	;
+		U32 philip_std  				:1	;
+		U32 ws_16b                      :1	;
+		U32 i2s0_to_dac                 :1	;
+		U32 i2s1_to_dac                 :1	;
+		U32 i2s2_to_dac                 :1	;
+		U32 i2s3_to_dac                 :1	;
+		U32 i2s0_to_hdmi                :1	;
+		U32 i2s1_to_hdmi                :1	;
+		U32 i2s2_to_hdmi                :1	;
+		U32 i2s3_to_hdmi                :1	;
+        U32 i2s0_flush                  :1  ;
+        U32 i2s1_flush                  :1  ;
+        U32 i2s2_flush                  :1  ;
+        U32 i2s3_flush                  :1  ;
+        U32 mixer0_enable               :1  ;
+        U32 mixer1_enable               :1  ;
+        U32 mixer2_enable               :1  ;
+        U32 mixer3_enable               :1  ;
+        U32 i2s0_unify                   :1  ;
+        U32 i2s1_unify                   :1  ;
+        U32 i2s2_unify                   :1  ;
+        U32 i2s3_unify                   :1  ;
+		U32 i2s0_mixer_sync				:1   ;
+		U32 i2s1_mixer_sync				:1   ;
+		U32 i2s2_mixer_sync				:1   ;
+		U32 i2s3_mixer_sync				:1   ;
+		U32 i2s_hbr						:1  ;
+        U32 reserved                    :3 ;
+	}bit;
+}I2S_CONTROL, *PI2S_CONTROL;
+
+
+void clock_audio_setclock(AUDIO_CLOCK_MODE audclk_rate);
+I2S_RETURN_VALUE i2s_channel_set(I2S_ELEMENT_t *i2s_element);
+
+static int do_audio (cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[])
+{
+	I2S_ELEMENT_t i2s_element;
+	int sample_rate;
+	unsigned int start, size;
+	int i;
+	
+	if (argc < 4)
+		return cmd_usage(cmdtp);
+	
+	sample_rate = simple_strtoul(argv[1], NULL, 10);
+	start = simple_strtoul(argv[2], NULL, 16);
+	size = simple_strtoul(argv[3], NULL, 16);
+	if(sample_rate < 0 || sample_rate > _AUDIO_8KHz){
+		printf("Invalid sample rate specified. Valid sample rates are:\n");
+		for(i = 0; i <= _AUDIO_8KHz; i++){
+			printf("\t%d: %d Hz\n", i, aud_pll_cfg[i][aud_target_freq]);
+		}
+		return -1;
+	}
+	if(start & 0x7 || size & 0x7){
+		printf("Start address and size must be aligned to 8 bytes\n");
+		return -1;
+	}
+
+	power_clk_write(CLOCK_PLL_CLK_EN, power_clk_read(CLOCK_PLL_CLK_EN) | (1 << 22));
+	printf("[CLOCK_PLL_CLK_EN] = %08x\n", power_clk_read(CLOCK_PLL_CLK_EN));
+
+	printf("Setting audio clock to %d Hz\n", aud_pll_cfg[sample_rate][aud_target_freq]);
+	clock_audio_setclock(sample_rate);
+	
+    i2s_element.i2s_id = I2S_0;
+    i2s_element.UP0 = start + size;
+    i2s_element.LOW0 = start;
+    i2s_element.SCAL0 = 0x1000000;
+    i2s_element.UP1 = i2s_element.UP0;
+    i2s_element.LOW1 = i2s_element.LOW0;
+    i2s_element.SCAL1 = i2s_element.SCAL0;
+    i2s_element.mixing = 0;
+    i2s_element.todac = 0;
+    i2s_element.tohdmi = 1;
+    i2s_element.unify = 0;
+    i2s_element.mix_sync = 0;
+
+	printf("Setting up I2S channel 0\n");
+	if(i2s_channel_set(&i2s_element) != I2S_SUCCESS){
+		printf("Setup failed\n");
+		return -1;
+	}
+
+	printf("[CSM1300_AUD_I2S_CNTL] = 0x%08x\n", read_ahb32(CSM1300_AUD_I2S_CNTL));
+	printf("Setting up I2S DMA from 0x%08x to 0x%08x\n", start, start + size - 8);
+	write_ahb32(CSM1300_AUD_I2S_WP0 + 0x100 * 0, start + size - 8);
+
+	return 0;
+}
+
+I2S_RETURN_VALUE i2s_channel_set(I2S_ELEMENT_t *i2s_element)
+{
+	U32 i2s_offset;
+	U32 I2S_RP_reg, I2S_WP_reg, I2S_UP_reg, I2S_LOW_reg, I2S_SCAL_reg;
+	U32 control_status = 0;
+
+	if (i2s_element->i2s_id > I2S_3|| 
+		(i2s_element->UP0 & 0x7) ||
+		(i2s_element->LOW0 & 0x7) ||
+		(i2s_element->UP1 & 0x7) ||
+		(i2s_element->LOW1 & 0x7) ||
+		(i2s_element->LOW0 > i2s_element->UP0) ||
+		(i2s_element->LOW1 > i2s_element->UP1)
+		)
+	{
+		return I2S_FAILED; 
+	}
+
+	i2s_offset = i2s_element->i2s_id;
+
+	I2S_RP_reg = CSM1300_AUD_I2S_RP0 + 0x100*i2s_offset;
+	I2S_WP_reg = CSM1300_AUD_I2S_WP0 + 0x100*i2s_offset; 
+	I2S_UP_reg = CSM1300_AUD_I2S_UP0 + 0x100*i2s_offset;
+	I2S_LOW_reg = CSM1300_AUD_I2S_LOW0 + 0x100*i2s_offset;
+	I2S_SCAL_reg = CSM1300_AUD_I2S_SCAL0 + 0x100*i2s_offset;
+	write_ahb32(I2S_RP_reg, i2s_element->LOW0);
+	write_ahb32(I2S_WP_reg, i2s_element->LOW0);
+	write_ahb32(I2S_UP_reg, i2s_element->UP0);
+	write_ahb32(I2S_LOW_reg, i2s_element->LOW0);
+	write_ahb32(I2S_SCAL_reg, i2s_element->SCAL0);
+
+	I2S_RP_reg = CSM1300_AUD_I2S_RP1 + 0x100*i2s_offset;
+	I2S_WP_reg = CSM1300_AUD_I2S_WP1 + 0x100*i2s_offset; 
+	I2S_UP_reg = CSM1300_AUD_I2S_UP1 + 0x100*i2s_offset;
+	I2S_LOW_reg = CSM1300_AUD_I2S_LOW1 + 0x100*i2s_offset;
+	I2S_SCAL_reg = CSM1300_AUD_I2S_SCAL1 + 0x100*i2s_offset;
+	write_ahb32(I2S_RP_reg, i2s_element->LOW1);
+	write_ahb32(I2S_WP_reg, i2s_element->LOW1);
+	write_ahb32(I2S_UP_reg, i2s_element->UP1);
+	write_ahb32(I2S_LOW_reg, i2s_element->LOW1);
+	write_ahb32(I2S_SCAL_reg, i2s_element->SCAL1);
+
+	control_status = read_ahb32(CSM1300_AUD_I2S_CNTL);
+
+	if (i2s_element->mixing == 1)
+		control_status |= 1<<(i2s_offset + 16);
+	else
+		control_status &= ~(1<<(i2s_offset + 16));
+
+	if (i2s_element->tohdmi == 1)
+		control_status |= 1<<(i2s_offset + 8);
+	else
+		control_status &= ~(1<<(i2s_offset + 8));
+
+	if (i2s_element->todac == 1)
+		control_status |= 1<<(i2s_offset + 4);
+	else
+		control_status &= ~(1<<(i2s_offset + 4));
+
+	if (i2s_element->unify == 1)
+		control_status |= 1<<(i2s_offset + 20);
+	else
+		control_status &= ~(1<<(i2s_offset + 20));
+
+	if (i2s_element->mix_sync == 1)
+		control_status |= 1<<(i2s_offset + 24);
+	else
+		control_status &= ~(1<<(i2s_offset + 24));
+
+	write_ahb32(CSM1300_AUD_I2S_CNTL, control_status);
+
+	return I2S_SUCCESS;    
+}
+
+I2S_RETURN_VALUE i2s_flush_simple(I2S_ID i2s_id)
+{
+    
+    U32 i2s_offset;
+    
+    U32 control_status;
+
+    i2s_offset = i2s_id;
+    if (i2s_offset > I2S_3)
+    {
+        return I2S_FAILED;
+    }
+
+    control_status = read_ahb32(CSM1300_AUD_I2S_CNTL);
+
+    /* set flush bit */
+    control_status |= 1<<(i2s_offset + 12);
+    write_ahb32(CSM1300_AUD_I2S_CNTL, control_status);
+
+    /* clear flush bit */
+    control_status &= ~(1<<(i2s_offset + 12));
+    write_ahb32(CSM1300_AUD_I2S_CNTL, control_status);
+
+    return I2S_SUCCESS;
+}
+
+
+void clock_audio_setclock(AUDIO_CLOCK_MODE audclk_rate)
+{
+    unsigned int   data;
+
+   // printk("CNC1900 Audio Target freq = %d\n", aud_pll_cfg[audclk_rate][aud_target_freq]);
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) & 0xFFFFF7FF;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //disable audio pcm clock
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) & 0xFFFFFFCF;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //aud pll & divider reset
+
+    power_clk_write(PLL_AUD_PARA_Q, aud_pll_cfg[audclk_rate][audpll_div_Q]);
+    power_clk_write(PLL_AUD_PARA_F, aud_pll_cfg[audclk_rate][audpll_div_F]);
+    power_clk_write(CLOCK_AUD_DIV, aud_pll_cfg[audclk_rate][audclk_postdiv]);
+
+    udelay(2);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000010;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert audio pll reset
+
+    udelay(70);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000030;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert audio divider reset
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) | 0x00000800;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //enable audio pcm clock
+
+}
+
+U_BOOT_CMD(
+	audio, 4, 1, do_audio,
+	"output PCM samples to I2S0",
+	"sample_rate address size_in_byte"
+);
+
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_cnc1900_otp.c u-boot-2011.06/common/cmd_cnc1900_otp.c
